library make_rtcg;

uses
  Windows,
  kol,
  CGTShare in '..\..\CGTShare.pas';



function buildGetParamsProc(var params: TBuildParams): Integer; cdecl;
begin
  params.flags := CGMP_RUN;
  Result := CG_SUCCESS;
end;

function buildMakePrj(const params: TBuildMakePrjRec): Integer; cdecl;
var
  S: PStream;
  Fn: string;
begin
  Fn := params.prjFilename;
  S := NewWriteFileStream(Fn);
  S.Write(params.result^, Strlen(params.result));
  S.Free;
  Result := CG_SUCCESS;
end;

function buildCompliteProc(const params:TBuildCompliteRec): Integer; cdecl;
begin
  Result := CG_SUCCESS;
end;

function buildRunProc(var params: TBuildRunRec): Integer; cdecl;
var
  CmdLine, WorkDir: string;
  SI: TStartupInfo;
  PI: TProcessInformation;
begin
  WorkDir := ExtractFilePath(params.FileName);
  CmdLine := WorkDir + ExtractFileNameWOext(params.FileName) + '.exe';

  FillChar( SI, SizeOf(TStartupInfo), 0);
  with SI do
  begin
    cb := SizeOf(TStartupInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := SW_SHOWDEFAULT;
  end;
  
  if CreateProcess(nil, PChar(CmdLine), nil, nil, false, CREATE_DEFAULT_ERROR_MODE, nil, PChar(WorkDir), SI, PI)
  then
  begin
    WaitForSingleObject(PI.hProcess, INFINITE);
    CloseHandle(PI.hThread);
    CloseHandle(PI.hProcess);
  end;
  

  Result := CG_SUCCESS;
end;

function buildStopProc(var params: TBuildRunRec): Integer; cdecl;
begin
  TerminateProcess(Cardinal(Params.data), 0);
  Result := CG_SUCCESS;
end;

exports
  buildGetParamsProc,
  buildMakePrj,
  buildCompliteProc,
  buildRunProc,
  buildStopProc;

begin

end.

